import{s as et,f as nt,n as it,o as at}from"../chunks/scheduler.63274e7e.js";import{S as ot,i as st,g as l,s as o,r as j,A as lt,h as r,f as n,c as s,j as D,u as F,x as $,k as p,y as rt,a as i,v as R,d as S,t as z,w as K}from"../chunks/index.bf3f3f8e.js";import{H as N}from"../chunks/Heading.500d2301.js";function mt(O){let m,b,x,H,u,T,h,X="Creating realistic animations is one of the <strong>most challenging tasks in game development.</strong>",P,f,Y="Usually, animation is <strong>either made by hand</strong> (but labor-intensive) or using <strong>expansive motion capture technology.</strong> Fortunately, we are starting to see some AI tools <strong>that generate animation based on a text prompt and some that extract animations from a video.</strong>",k,c,A,w,B="With Muse Animate, you can <strong>generate animations based on text-prompt directly on your Unity project 🤯.</strong>",L,d,J="We’re going to use it in an upcoming unit 🔥.",C,g,Q='👉 <a href="https://muse.unity.com/en-us/explore" rel="nofollow">https://muse.unity.com/en-us/explore</a>',E,y,I,v,V='With <a href="http://plask.ai/" rel="nofollow">Plask.AI</a> you <strong>simply capture a video with your phone, import it to the website and you can extract and edit the animations.</strong>',U,_,Z='👉 <a href="https://plask.ai/" rel="nofollow">https://plask.ai/</a>',q,a,tt,G,M,W;return u=new N({props:{title:"Animation Generation 💃",local:"animation-generation-",headingTag:"h1"}}),c=new N({props:{title:"Generate Animation with Unity Muse Animate 🔒💸",local:"generate-animation-with-unity-muse-animate-",headingTag:"h2"}}),y=new N({props:{title:"Do motion capture without expansive tools with Plask.AI 🔒💸",local:"do-motion-capture-without-expansive-tools-with-plaskai-",headingTag:"h2"}}),{c(){m=l("meta"),b=o(),x=l("p"),H=o(),j(u.$$.fragment),T=o(),h=l("p"),h.innerHTML=X,P=o(),f=l("p"),f.innerHTML=Y,k=o(),j(c.$$.fragment),A=o(),w=l("p"),w.innerHTML=B,L=o(),d=l("p"),d.textContent=J,C=o(),g=l("p"),g.innerHTML=Q,E=o(),j(y.$$.fragment),I=o(),v=l("p"),v.innerHTML=V,U=o(),_=l("p"),_.innerHTML=Z,q=o(),a=l("iframe"),G=o(),M=l("p"),this.h()},l(t){const e=lt("svelte-u9bgzb",document.head);m=r(e,"META",{name:!0,content:!0}),e.forEach(n),b=s(t),x=r(t,"P",{}),D(x).forEach(n),H=s(t),F(u.$$.fragment,t),T=s(t),h=r(t,"P",{"data-svelte-h":!0}),$(h)!=="svelte-1701jdw"&&(h.innerHTML=X),P=s(t),f=r(t,"P",{"data-svelte-h":!0}),$(f)!=="svelte-q4i0ug"&&(f.innerHTML=Y),k=s(t),F(c.$$.fragment,t),A=s(t),w=r(t,"P",{"data-svelte-h":!0}),$(w)!=="svelte-133kyds"&&(w.innerHTML=B),L=s(t),d=r(t,"P",{"data-svelte-h":!0}),$(d)!=="svelte-1ldkn2p"&&(d.textContent=J),C=s(t),g=r(t,"P",{"data-svelte-h":!0}),$(g)!=="svelte-mtihsn"&&(g.innerHTML=Q),E=s(t),F(y.$$.fragment,t),I=s(t),v=r(t,"P",{"data-svelte-h":!0}),$(v)!=="svelte-1u3kq0c"&&(v.innerHTML=V),U=s(t),_=r(t,"P",{"data-svelte-h":!0}),$(_)!=="svelte-1akibpx"&&(_.innerHTML=Z),q=s(t),a=r(t,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0,referrerpolicy:!0}),D(a).forEach(n),G=s(t),M=r(t,"P",{}),D(M).forEach(n),this.h()},h(){p(m,"name","hf:doc:metadata"),p(m,"content",pt),p(a,"width","560"),p(a,"height","315"),nt(a.src,tt="https://www.youtube.com/embed/OKHfD7WEzHs?si=po8dHwyuyX_N_bMR")||p(a,"src",tt),p(a,"title","YouTube video player"),p(a,"frameborder","0"),p(a,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),p(a,"referrerpolicy","strict-origin-when-cross-origin"),a.allowFullscreen=""},m(t,e){rt(document.head,m),i(t,b,e),i(t,x,e),i(t,H,e),R(u,t,e),i(t,T,e),i(t,h,e),i(t,P,e),i(t,f,e),i(t,k,e),R(c,t,e),i(t,A,e),i(t,w,e),i(t,L,e),i(t,d,e),i(t,C,e),i(t,g,e),i(t,E,e),R(y,t,e),i(t,I,e),i(t,v,e),i(t,U,e),i(t,_,e),i(t,q,e),i(t,a,e),i(t,G,e),i(t,M,e),W=!0},p:it,i(t){W||(S(u.$$.fragment,t),S(c.$$.fragment,t),S(y.$$.fragment,t),W=!0)},o(t){z(u.$$.fragment,t),z(c.$$.fragment,t),z(y.$$.fragment,t),W=!1},d(t){t&&(n(b),n(x),n(H),n(T),n(h),n(P),n(f),n(k),n(A),n(w),n(L),n(d),n(C),n(g),n(E),n(I),n(v),n(U),n(_),n(q),n(a),n(G),n(M)),n(m),K(u,t),K(c,t),K(y,t)}}}const pt='{"title":"Animation Generation 💃","local":"animation-generation-","sections":[{"title":"Generate Animation with Unity Muse Animate 🔒💸","local":"generate-animation-with-unity-muse-animate-","sections":[],"depth":2},{"title":"Do motion capture without expansive tools with Plask.AI 🔒💸","local":"do-motion-capture-without-expansive-tools-with-plaskai-","sections":[],"depth":2}],"depth":1}';function ut(O){return at(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class wt extends ot{constructor(m){super(),st(this,m,ut,mt,et,{})}}export{wt as component};
