import{s as ui,f as x,n as ci,o as fi}from"../chunks/scheduler.63274e7e.js";import{S as di,i as wi,g as o,s as r,r as T,A as gi,h as s,f as i,c as n,j as b,u as _,x as m,k as l,y as vi,a,v as C,d as A,t as M,w as $}from"../chunks/index.bf3f3f8e.js";import{H as I}from"../chunks/Heading.500d2301.js";function yi(Ct){let L,Te,ye,_e,H,Ce,P,At="To better understand the theory behind classical AI in Games, the best resources to watch are the excellent <strong>series of videos by Dr. Tommy Thompson on AI in Games called AI 101</strong>.",Ae,k,Mt='<a href="https://twitter.com/AIandGames" rel="nofollow">Dr Tommy Thompson</a> works as an AI developer, researcher and consultant in the video game industry. In his <a href="https://www.youtube.com/@AIandGames" rel="nofollow">YouTube channel, AI and Games</a>, he studies what AI algorithms are used in games and how.',Me,F,$t="We would like to thank Dr. Tommy Thompson for providing detailed introductions for each video in this section.",$e,E,Ie,G,It="When we talk about ‘AI in video games’ nowadays, <strong>what do we really mean?</strong> Game AI? Deep Learning? Generative AI?  All of these are valid, <strong>but understanding how and where they’re adopted is super important</strong>. In this episode we provide a high-level overview of how artificial intelligence is adopted across the industry.",xe,h,xt,Le,D,He,U,Lt="If you’ve build AI for your games (or simply played a lot of them too), <strong>you’ll notice how difficult it is to make AI really shine in your game</strong>. In this episode we dig into some of the fundamental challenges faced by developers.",Pe,p,Ht,ke,S,Fe,q,Pt="As games moved into 3D, one of the biggest challenges was how to ensure a non-player character (NPC) could successfully move from one place to another.  The solution is what is typically referred to as a ‘navigation mesh’: a data structure that <strong>tessellates a surface with a collection of polygons indicate of navigable space</strong>. This concept, popularised by <em>Quake III Arena</em> in 1999 has since become a <strong>standard tool in all 3D commercial game engines</strong>. Despite this, <strong>successful navigation is still a challenge for modern games</strong> to this day given the myriad of design challenges it presents.",Ee,u,kt,Ge,R,Ft="📚 Additional Readings:",De,B,Et='<li><p>Theory and Overview of Navigation Meshes</p> <ul><li><a href="https://en.wikipedia.org/wiki/Navigation_mesh" rel="nofollow">https://en.wikipedia.org/wiki/Navigation_mesh</a></li> <li><a href="https://www.gamedev.net/articles/programming/artificial-intelligence/navigation-meshes-and-pathfinding-r4880/" rel="nofollow">https://www.gamedev.net/articles/programming/artificial-intelligence/navigation-meshes-and-pathfinding-r4880/</a></li></ul></li> <li><p>Nav Meshes in Unity</p> <ul><li><a href="https://www.youtube.com/watch?v=CHV1ymlw-P8&amp;ab_channel=Brackeys" rel="nofollow">https://www.youtube.com/watch?v=CHV1ymlw-P8&amp;ab_channel=Brackeys</a></li></ul></li> <li><p>Nav Meshes in Unreal Engine 5</p> <ul><li><a href="https://docs.unrealengine.com/5.3/en-US/basic-navigation-in-unreal-engine/" rel="nofollow">https://docs.unrealengine.com/5.3/en-US/basic-navigation-in-unreal-engine/</a></li></ul></li>',Ue,N,Se,V,Gt="While there are a myriad of approaches for controlling NPCs in games - many of which earn their own episodes in this series - <strong>the standard is Behaviour Trees</strong>. These relatively straightforward data structures were originally popularised by the <em>Halo</em> franchise and have since become the norm for many large-scale big budget productions <strong>and are the default AI tool in Unreal Engine</strong>.",qe,c,Dt,Re,O,Ut="📚 Additional Readings:",Be,W,St='<li>Behavior Trees in Unreal: <a href="https://docs.unrealengine.com/5.3/en-US/behavior-trees-in-unreal-engine/" rel="nofollow">https://docs.unrealengine.com/5.3/en-US/behavior-trees-in-unreal-engine/</a></li>',Ne,Y,Ve,j,qt="<em>Finite State Machines</em> (FSMs) have existed since the very beginning not just of AI for video games, but the field of artificial intelligence as a whole.",Oe,z,Rt="A simple system of connected ‘states’ that allows for designers <strong>to encapsulate how a character should operate in specific contexts</strong>. Many of your favourite games from the 1980s and 1990s adopted FSMs, from the arcade days of <em>Pac-Man</em> to the birth of first-person shooters with <em>DOOM</em>.",We,K,Bt="While they’re still used today in popular franchises like <em>Marvel’s Spider-Man</em> and <em>The Last of Us</em>, this is largely thanks to the implementation in Valve’s <em>Half-Life</em> which <strong>set a new standard for their adoption in games</strong>.",Ye,f,Nt,je,J,Vt="📚 Additional Readings:",ze,Q,Ot='<li>Finite-State Machines: Theory and Implementation: <a href="https://code.tutsplus.com/finite-state-machines-theory-and-implementation--gamedev-11867t" rel="nofollow">https://code.tutsplus.com/finite-state-machines-theory-and-implementation—gamedev-11867t</a></li>',Ke,X,Je,Z,Wt="<em>Goal Oriented Action Planning</em> was one of the <strong>most important innovations in AI for games in the mid 2000s</strong> and is arguably what led to Monolith’s first-person shooter <em>F.E.A.R</em>. still being considered to have the best AI in video games.  But it’s really quite simple: <strong>the combination of finite state machines with AI planning technology that dates back as far as the 1970s.</strong>",Qe,d,Yt,Xe,ee,jt="📚 Additional Readings:",Ze,te,zt='<li>Holistic 3D’s video on GOAP: <a href="https://www.youtube.com/watch?v=jUSrVF8mve4&amp;ab_channel=Holistic3D" rel="nofollow">https://www.youtube.com/watch?v=jUSrVF8mve4&amp;ab_channel=Holistic3D</a></li>',et,ie,tt,ae,Kt="So far the topics have focused on AI that is built <strong>to control non-player characters</strong>, but what if we want to use AI not just for individual behaviours <strong>but also designing the player experience</strong>.",it,le,Jt="This has led to a collection of approaches collectively known as <em>Director AI</em>, with the term adopted for this design philosophy derived from its use in Valve’s <em>Left 4 Dead</em>.",at,w,Qt,lt,re,rt,ne,Xt="Sometimes an AI system could have a collection of valid options to select from, <strong>but it can’t tell which is the best for this context</strong>.",nt,oe,Zt="While we could now train a model using deep learning to determine contextual validity, <strong>we have long since used utility AI as a means to embed designer knowledge to determine the validity of an action or goal</strong>.",ot,g,ei,st,se,ti="📚 Additional Readings:",mt,me,ii='<li><a href="https://youtu.be/9gf2MT-IOsg?si=omZdMpayS5-qQJkE" rel="nofollow">How the AI of The Sims Works</a></li> <li><a href="https://www.gameaipro.com/GameAIPro/GameAIPro_Chapter09_An_Introduction_to_Utility_Theory.pdf" rel="nofollow">“An Introduction to Utility AI Theory” - Game AI Pro v2</a></li> <li><a href="https://www.gameaipro.com/GameAIPro3/GameAIPro3_Chapter31_Behavior_Decision_System_Dragon_Age_Inquisition%E2%80%99s_Utility_Scoring_Architecture.pdf" rel="nofollow">Behavior Decision System: Dragon Age Inquisition’s Utility Scoring Architecture” - Game AI Pro v3</a></li>',ht,he,pt,pe,ai="While building AI for games is difficult, communicating the inner workings of these systems to players is just as demanding.  One of the simplest solutions to this problem is the use of <em>barks</em>: <strong>pre-built text and/or audio that helps communicate the state of an AI agent in ways that make sense in the context of play</strong>.",ut,ue,li="That might sound pretty simple, <strong>but you’d be surprised how effective it is in practice</strong>.",ct,v,ri,ft,ce,ni="📚 Additional Readings:",dt,fe,oi='<li><a href="https://www.youtube.com/watch?v=bwdYL0KFA_U&amp;t=0s" rel="nofollow">Interview with Supergiant on the dialogue of Hades</a></li> <li><a href="https://www.youtube.com/watch?v=tAbBID3N64A&amp;t=0s" rel="nofollow">Elan Ruskin on Fuzzy Pattern Matching for Dialogue</a></li> <li><a href="https://www.youtube.com/watch?v=m5KJSAj4afg&amp;t=0s" rel="nofollow">Darren Korb and Greg Kasavin on the dialogue systems of Hades</a></li> <li><a href="https://www.gdcvault.com/play/1020386/A-Context-Aware-Character-Dialog" rel="nofollow">Jason Gregory on context-aware dialogue in The Last of Us</a></li>',wt,de,si="Now that we studed the theory behind these classical AI in Games algorithms. Let’s <strong>learn how to implement some of them in Unity and Unreal</strong>.",gt,we,vt,ge,mi="As you will have gathered watching these videos, machine learning has not been as prominent in the adoption of AI for non-player characters when compared to symbolic methods.",yt,ve,hi="In this episode we dig into not just how it has been used in player facing systems, but also the interesting problem spaces it has been applied to in video games production.",bt,y,pi,Tt,be,_t;return H=new I({props:{title:"AI 101 by AI and Games (Dr. Tommy Thompson)",local:"ai-101-by-ai-and-games-dr-tommy-thompson",headingTag:"h1"}}),E=new I({props:{title:"Chapter 1: How AI is Actually Used in the Video Games Industry (2024) 🤖",local:"chapter-1-how-ai-is-actually-used-in-the-video-games-industry-2024-",headingTag:"h2"}}),D=new I({props:{title:"Chapter 2: Why is It Difficult to Make Good AI for Games? 🤔",local:"chapter-2-why-is-it-difficult-to-make-good-ai-for-games-",headingTag:"h2"}}),S=new I({props:{title:"Chapter 3: Navigation Meshes 🗺️",local:"chapter-3-navigation-meshes-",headingTag:"h2"}}),N=new I({props:{title:"Chapter 4: Behavior Trees 🌳",local:"chapter-4-behavior-trees-",headingTag:"h2"}}),Y=new I({props:{title:"Chapter 5: Finite State Machines 🤖",local:"chapter-5-finite-state-machines-",headingTag:"h2"}}),X=new I({props:{title:"Chapter 6: Goal Oriented Action Planning 📝",local:"chapter-6-goal-oriented-action-planning-",headingTag:"h2"}}),ie=new I({props:{title:"Chapter 7: Director AI for Balancing In-Game Experiences 📣",local:"chapter-7-director-ai-for-balancing-in-game-experiences-",headingTag:"h2"}}),re=new I({props:{title:"Chapter 8: Utility AI Helps NPCs Decide What To Do Next 📈",local:"chapter-8-utility-ai-helps-npcs-decide-what-to-do-next-",headingTag:"h2"}}),he=new I({props:{title:"Chapter 9: How Barks Make Videogame NPCs Look Smarter 🗣️",local:"chapter-9-how-barks-make-videogame-npcs-look-smarter-",headingTag:"h2"}}),we=new I({props:{title:"Chapter 10: How Machine Learning is Transforming the Video Games Industry 🤖",local:"chapter-10-how-machine-learning-is-transforming-the-video-games-industry-",headingTag:"h2"}}),{c(){L=o("meta"),Te=r(),ye=o("p"),_e=r(),T(H.$$.fragment),Ce=r(),P=o("p"),P.innerHTML=At,Ae=r(),k=o("p"),k.innerHTML=Mt,Me=r(),F=o("p"),F.textContent=$t,$e=r(),T(E.$$.fragment),Ie=r(),G=o("p"),G.innerHTML=It,xe=r(),h=o("iframe"),Le=r(),T(D.$$.fragment),He=r(),U=o("p"),U.innerHTML=Lt,Pe=r(),p=o("iframe"),ke=r(),T(S.$$.fragment),Fe=r(),q=o("p"),q.innerHTML=Pt,Ee=r(),u=o("iframe"),Ge=r(),R=o("p"),R.textContent=Ft,De=r(),B=o("ul"),B.innerHTML=Et,Ue=r(),T(N.$$.fragment),Se=r(),V=o("p"),V.innerHTML=Gt,qe=r(),c=o("iframe"),Re=r(),O=o("p"),O.textContent=Ut,Be=r(),W=o("ul"),W.innerHTML=St,Ne=r(),T(Y.$$.fragment),Ve=r(),j=o("p"),j.innerHTML=qt,Oe=r(),z=o("p"),z.innerHTML=Rt,We=r(),K=o("p"),K.innerHTML=Bt,Ye=r(),f=o("iframe"),je=r(),J=o("p"),J.textContent=Vt,ze=r(),Q=o("ul"),Q.innerHTML=Ot,Ke=r(),T(X.$$.fragment),Je=r(),Z=o("p"),Z.innerHTML=Wt,Qe=r(),d=o("iframe"),Xe=r(),ee=o("p"),ee.textContent=jt,Ze=r(),te=o("ul"),te.innerHTML=zt,et=r(),T(ie.$$.fragment),tt=r(),ae=o("p"),ae.innerHTML=Kt,it=r(),le=o("p"),le.innerHTML=Jt,at=r(),w=o("iframe"),lt=r(),T(re.$$.fragment),rt=r(),ne=o("p"),ne.innerHTML=Xt,nt=r(),oe=o("p"),oe.innerHTML=Zt,ot=r(),g=o("iframe"),st=r(),se=o("p"),se.textContent=ti,mt=r(),me=o("ul"),me.innerHTML=ii,ht=r(),T(he.$$.fragment),pt=r(),pe=o("p"),pe.innerHTML=ai,ut=r(),ue=o("p"),ue.innerHTML=li,ct=r(),v=o("iframe"),ft=r(),ce=o("p"),ce.textContent=ni,dt=r(),fe=o("ul"),fe.innerHTML=oi,wt=r(),de=o("p"),de.innerHTML=si,gt=r(),T(we.$$.fragment),vt=r(),ge=o("p"),ge.textContent=mi,yt=r(),ve=o("p"),ve.textContent=hi,bt=r(),y=o("iframe"),Tt=r(),be=o("p"),this.h()},l(e){const t=gi("svelte-u9bgzb",document.head);L=s(t,"META",{name:!0,content:!0}),t.forEach(i),Te=n(e),ye=s(e,"P",{}),b(ye).forEach(i),_e=n(e),_(H.$$.fragment,e),Ce=n(e),P=s(e,"P",{"data-svelte-h":!0}),m(P)!=="svelte-1o2krf1"&&(P.innerHTML=At),Ae=n(e),k=s(e,"P",{"data-svelte-h":!0}),m(k)!=="svelte-1y2sn1i"&&(k.innerHTML=Mt),Me=n(e),F=s(e,"P",{"data-svelte-h":!0}),m(F)!=="svelte-1veg10s"&&(F.textContent=$t),$e=n(e),_(E.$$.fragment,e),Ie=n(e),G=s(e,"P",{"data-svelte-h":!0}),m(G)!=="svelte-x8b23b"&&(G.innerHTML=It),xe=n(e),h=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(h).forEach(i),Le=n(e),_(D.$$.fragment,e),He=n(e),U=s(e,"P",{"data-svelte-h":!0}),m(U)!=="svelte-50p0io"&&(U.innerHTML=Lt),Pe=n(e),p=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(p).forEach(i),ke=n(e),_(S.$$.fragment,e),Fe=n(e),q=s(e,"P",{"data-svelte-h":!0}),m(q)!=="svelte-dhwwzz"&&(q.innerHTML=Pt),Ee=n(e),u=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(u).forEach(i),Ge=n(e),R=s(e,"P",{"data-svelte-h":!0}),m(R)!=="svelte-qu4pcp"&&(R.textContent=Ft),De=n(e),B=s(e,"UL",{"data-svelte-h":!0}),m(B)!=="svelte-vjd647"&&(B.innerHTML=Et),Ue=n(e),_(N.$$.fragment,e),Se=n(e),V=s(e,"P",{"data-svelte-h":!0}),m(V)!=="svelte-1wkmmnl"&&(V.innerHTML=Gt),qe=n(e),c=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(c).forEach(i),Re=n(e),O=s(e,"P",{"data-svelte-h":!0}),m(O)!=="svelte-qu4pcp"&&(O.textContent=Ut),Be=n(e),W=s(e,"UL",{"data-svelte-h":!0}),m(W)!=="svelte-1mi1m4f"&&(W.innerHTML=St),Ne=n(e),_(Y.$$.fragment,e),Ve=n(e),j=s(e,"P",{"data-svelte-h":!0}),m(j)!=="svelte-1qjtyaa"&&(j.innerHTML=qt),Oe=n(e),z=s(e,"P",{"data-svelte-h":!0}),m(z)!=="svelte-1aneiea"&&(z.innerHTML=Rt),We=n(e),K=s(e,"P",{"data-svelte-h":!0}),m(K)!=="svelte-6ops7c"&&(K.innerHTML=Bt),Ye=n(e),f=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(f).forEach(i),je=n(e),J=s(e,"P",{"data-svelte-h":!0}),m(J)!=="svelte-qu4pcp"&&(J.textContent=Vt),ze=n(e),Q=s(e,"UL",{"data-svelte-h":!0}),m(Q)!=="svelte-aaxgxl"&&(Q.innerHTML=Ot),Ke=n(e),_(X.$$.fragment,e),Je=n(e),Z=s(e,"P",{"data-svelte-h":!0}),m(Z)!=="svelte-ca6co4"&&(Z.innerHTML=Wt),Qe=n(e),d=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(d).forEach(i),Xe=n(e),ee=s(e,"P",{"data-svelte-h":!0}),m(ee)!=="svelte-qu4pcp"&&(ee.textContent=jt),Ze=n(e),te=s(e,"UL",{"data-svelte-h":!0}),m(te)!=="svelte-vfdwhn"&&(te.innerHTML=zt),et=n(e),_(ie.$$.fragment,e),tt=n(e),ae=s(e,"P",{"data-svelte-h":!0}),m(ae)!=="svelte-1ynaf5t"&&(ae.innerHTML=Kt),it=n(e),le=s(e,"P",{"data-svelte-h":!0}),m(le)!=="svelte-1xhvdus"&&(le.innerHTML=Jt),at=n(e),w=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(w).forEach(i),lt=n(e),_(re.$$.fragment,e),rt=n(e),ne=s(e,"P",{"data-svelte-h":!0}),m(ne)!=="svelte-1r2merz"&&(ne.innerHTML=Xt),nt=n(e),oe=s(e,"P",{"data-svelte-h":!0}),m(oe)!=="svelte-1c9z208"&&(oe.innerHTML=Zt),ot=n(e),g=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(g).forEach(i),st=n(e),se=s(e,"P",{"data-svelte-h":!0}),m(se)!=="svelte-qu4pcp"&&(se.textContent=ti),mt=n(e),me=s(e,"UL",{"data-svelte-h":!0}),m(me)!=="svelte-4phde1"&&(me.innerHTML=ii),ht=n(e),_(he.$$.fragment,e),pt=n(e),pe=s(e,"P",{"data-svelte-h":!0}),m(pe)!=="svelte-t8g0no"&&(pe.innerHTML=ai),ut=n(e),ue=s(e,"P",{"data-svelte-h":!0}),m(ue)!=="svelte-vej7pb"&&(ue.innerHTML=li),ct=n(e),v=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(v).forEach(i),ft=n(e),ce=s(e,"P",{"data-svelte-h":!0}),m(ce)!=="svelte-qu4pcp"&&(ce.textContent=ni),dt=n(e),fe=s(e,"UL",{"data-svelte-h":!0}),m(fe)!=="svelte-9ut6il"&&(fe.innerHTML=oi),wt=n(e),de=s(e,"P",{"data-svelte-h":!0}),m(de)!=="svelte-oo1mct"&&(de.innerHTML=si),gt=n(e),_(we.$$.fragment,e),vt=n(e),ge=s(e,"P",{"data-svelte-h":!0}),m(ge)!=="svelte-vt04qy"&&(ge.textContent=mi),yt=n(e),ve=s(e,"P",{"data-svelte-h":!0}),m(ve)!=="svelte-3ah6jp"&&(ve.textContent=hi),bt=n(e),y=s(e,"IFRAME",{width:!0,height:!0,src:!0,title:!0,frameborder:!0,allow:!0}),b(y).forEach(i),Tt=n(e),be=s(e,"P",{}),b(be).forEach(i),this.h()},h(){l(L,"name","hf:doc:metadata"),l(L,"content",bi),l(h,"width","560"),l(h,"height","315"),x(h.src,xt="https://www.youtube.com/embed/j3LW5no-5Ao?si=D34_eCOL8QlW-TTB")||l(h,"src",xt),l(h,"title","YouTube video player"),l(h,"frameborder","0"),l(h,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),h.allowFullscreen="",l(p,"width","560"),l(p,"height","315"),x(p.src,Ht="https://www.youtube.com/embed/qCkqpRnk1oU?si=HVC3Got61oztHhqJ")||l(p,"src",Ht),l(p,"title","YouTube video player"),l(p,"frameborder","0"),l(p,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),p.allowFullscreen="",l(u,"width","560"),l(u,"height","315"),x(u.src,kt="https://www.youtube.com/embed/U5MTIh_KyBc?si=S26zVmHvbLwC4Lty")||l(u,"src",kt),l(u,"title","YouTube video player"),l(u,"frameborder","0"),l(u,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),u.allowFullscreen="",l(c,"width","560"),l(c,"height","315"),x(c.src,Dt="https://www.youtube.com/embed/6VBCXvfNlCM?si=Vc35IYS10A2vF4eX")||l(c,"src",Dt),l(c,"title","YouTube video player"),l(c,"frameborder","0"),l(c,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),c.allowFullscreen="",l(f,"width","560"),l(f,"height","315"),x(f.src,Nt="https://www.youtube.com/embed/JyF0oyarz4U?si=G-uM3ImtlK3Fr0Oe")||l(f,"src",Nt),l(f,"title","YouTube video player"),l(f,"frameborder","0"),l(f,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),f.allowFullscreen="",l(d,"width","560"),l(d,"height","315"),x(d.src,Yt="https://www.youtube.com/embed/PaOLBOuyswI?si=ELDIk11nEy8MpqTe&start=1")||l(d,"src",Yt),l(d,"title","YouTube video player"),l(d,"frameborder","0"),l(d,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),d.allowFullscreen="",l(w,"width","560"),l(w,"height","315"),x(w.src,Qt="https://www.youtube.com/embed/Mnt5zxb8W0Y?si=Yqa7tnFx5d75LCVg")||l(w,"src",Qt),l(w,"title","YouTube video player"),l(w,"frameborder","0"),l(w,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),w.allowFullscreen="",l(g,"width","560"),l(g,"height","315"),x(g.src,ei="https://www.youtube.com/embed/p3Jbp2cZg3Q?si=5kqN3FqnFW277BTc")||l(g,"src",ei),l(g,"title","YouTube video player"),l(g,"frameborder","0"),l(g,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),g.allowFullscreen="",l(v,"width","560"),l(v,"height","315"),x(v.src,ri="https://www.youtube.com/embed/u9VkW18IMzc?si=-5yovJKq2OCeOkf-&start=2")||l(v,"src",ri),l(v,"title","YouTube video player"),l(v,"frameborder","0"),l(v,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),v.allowFullscreen="",l(y,"width","560"),l(y,"height","315"),x(y.src,pi="https://www.youtube.com/embed/dm_yY-hddvE?si=ChqK_aCtOrV1qXq9")||l(y,"src",pi),l(y,"title","YouTube video player"),l(y,"frameborder","0"),l(y,"allow","accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"),y.allowFullscreen=""},m(e,t){vi(document.head,L),a(e,Te,t),a(e,ye,t),a(e,_e,t),C(H,e,t),a(e,Ce,t),a(e,P,t),a(e,Ae,t),a(e,k,t),a(e,Me,t),a(e,F,t),a(e,$e,t),C(E,e,t),a(e,Ie,t),a(e,G,t),a(e,xe,t),a(e,h,t),a(e,Le,t),C(D,e,t),a(e,He,t),a(e,U,t),a(e,Pe,t),a(e,p,t),a(e,ke,t),C(S,e,t),a(e,Fe,t),a(e,q,t),a(e,Ee,t),a(e,u,t),a(e,Ge,t),a(e,R,t),a(e,De,t),a(e,B,t),a(e,Ue,t),C(N,e,t),a(e,Se,t),a(e,V,t),a(e,qe,t),a(e,c,t),a(e,Re,t),a(e,O,t),a(e,Be,t),a(e,W,t),a(e,Ne,t),C(Y,e,t),a(e,Ve,t),a(e,j,t),a(e,Oe,t),a(e,z,t),a(e,We,t),a(e,K,t),a(e,Ye,t),a(e,f,t),a(e,je,t),a(e,J,t),a(e,ze,t),a(e,Q,t),a(e,Ke,t),C(X,e,t),a(e,Je,t),a(e,Z,t),a(e,Qe,t),a(e,d,t),a(e,Xe,t),a(e,ee,t),a(e,Ze,t),a(e,te,t),a(e,et,t),C(ie,e,t),a(e,tt,t),a(e,ae,t),a(e,it,t),a(e,le,t),a(e,at,t),a(e,w,t),a(e,lt,t),C(re,e,t),a(e,rt,t),a(e,ne,t),a(e,nt,t),a(e,oe,t),a(e,ot,t),a(e,g,t),a(e,st,t),a(e,se,t),a(e,mt,t),a(e,me,t),a(e,ht,t),C(he,e,t),a(e,pt,t),a(e,pe,t),a(e,ut,t),a(e,ue,t),a(e,ct,t),a(e,v,t),a(e,ft,t),a(e,ce,t),a(e,dt,t),a(e,fe,t),a(e,wt,t),a(e,de,t),a(e,gt,t),C(we,e,t),a(e,vt,t),a(e,ge,t),a(e,yt,t),a(e,ve,t),a(e,bt,t),a(e,y,t),a(e,Tt,t),a(e,be,t),_t=!0},p:ci,i(e){_t||(A(H.$$.fragment,e),A(E.$$.fragment,e),A(D.$$.fragment,e),A(S.$$.fragment,e),A(N.$$.fragment,e),A(Y.$$.fragment,e),A(X.$$.fragment,e),A(ie.$$.fragment,e),A(re.$$.fragment,e),A(he.$$.fragment,e),A(we.$$.fragment,e),_t=!0)},o(e){M(H.$$.fragment,e),M(E.$$.fragment,e),M(D.$$.fragment,e),M(S.$$.fragment,e),M(N.$$.fragment,e),M(Y.$$.fragment,e),M(X.$$.fragment,e),M(ie.$$.fragment,e),M(re.$$.fragment,e),M(he.$$.fragment,e),M(we.$$.fragment,e),_t=!1},d(e){e&&(i(Te),i(ye),i(_e),i(Ce),i(P),i(Ae),i(k),i(Me),i(F),i($e),i(Ie),i(G),i(xe),i(h),i(Le),i(He),i(U),i(Pe),i(p),i(ke),i(Fe),i(q),i(Ee),i(u),i(Ge),i(R),i(De),i(B),i(Ue),i(Se),i(V),i(qe),i(c),i(Re),i(O),i(Be),i(W),i(Ne),i(Ve),i(j),i(Oe),i(z),i(We),i(K),i(Ye),i(f),i(je),i(J),i(ze),i(Q),i(Ke),i(Je),i(Z),i(Qe),i(d),i(Xe),i(ee),i(Ze),i(te),i(et),i(tt),i(ae),i(it),i(le),i(at),i(w),i(lt),i(rt),i(ne),i(nt),i(oe),i(ot),i(g),i(st),i(se),i(mt),i(me),i(ht),i(pt),i(pe),i(ut),i(ue),i(ct),i(v),i(ft),i(ce),i(dt),i(fe),i(wt),i(de),i(gt),i(vt),i(ge),i(yt),i(ve),i(bt),i(y),i(Tt),i(be)),i(L),$(H,e),$(E,e),$(D,e),$(S,e),$(N,e),$(Y,e),$(X,e),$(ie,e),$(re,e),$(he,e),$(we,e)}}}const bi='{"title":"AI 101 by AI and Games (Dr. Tommy Thompson)","local":"ai-101-by-ai-and-games-dr-tommy-thompson","sections":[{"title":"Chapter 1: How AI is Actually Used in the Video Games Industry (2024) 🤖","local":"chapter-1-how-ai-is-actually-used-in-the-video-games-industry-2024-","sections":[],"depth":2},{"title":"Chapter 2: Why is It Difficult to Make Good AI for Games? 🤔","local":"chapter-2-why-is-it-difficult-to-make-good-ai-for-games-","sections":[],"depth":2},{"title":"Chapter 3: Navigation Meshes 🗺️","local":"chapter-3-navigation-meshes-","sections":[],"depth":2},{"title":"Chapter 4: Behavior Trees 🌳","local":"chapter-4-behavior-trees-","sections":[],"depth":2},{"title":"Chapter 5: Finite State Machines 🤖","local":"chapter-5-finite-state-machines-","sections":[],"depth":2},{"title":"Chapter 6: Goal Oriented Action Planning 📝","local":"chapter-6-goal-oriented-action-planning-","sections":[],"depth":2},{"title":"Chapter 7: Director AI for Balancing In-Game Experiences 📣","local":"chapter-7-director-ai-for-balancing-in-game-experiences-","sections":[],"depth":2},{"title":"Chapter 8: Utility AI Helps NPCs Decide What To Do Next 📈","local":"chapter-8-utility-ai-helps-npcs-decide-what-to-do-next-","sections":[],"depth":2},{"title":"Chapter 9: How Barks Make Videogame NPCs Look Smarter 🗣️","local":"chapter-9-how-barks-make-videogame-npcs-look-smarter-","sections":[],"depth":2},{"title":"Chapter 10: How Machine Learning is Transforming the Video Games Industry 🤖","local":"chapter-10-how-machine-learning-is-transforming-the-video-games-industry-","sections":[],"depth":2}],"depth":1}';function Ti(Ct){return fi(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Mi extends di{constructor(L){super(),wi(this,L,Ti,yi,ui,{})}}export{Mi as component};
